import 'package:example/employee/employee.controller.dart';
import 'package:flutter/material.dart';
import 'package:tecfy_basic_package/tecfy_basic_package.dart';

class EmployeeListPage extends TecfyStatefulWidget<EmployeeController> {
  EmployeeListPage({Key? key, EmployeeController? controller})
      : super(controller, key: key);

  @override
  _EmployeeListPageState createState() => _EmployeeListPageState();

  @override
  TecfyBeamerPageRoute? beamer() {
    return TecfyBeamerPageRoute('/employees',
        (p0, p1, p2) => BeamerService.beamPageEx(child: EmployeeListPage()));
  }
}

class _EmployeeListPageState
    extends TecfyState<EmployeeListPage, EmployeeController> {
  @override
  EmployeeController createController() => EmployeeController();

  @override
  Widget build(BuildContext context) {
    return TecfyMobileScaffold(
      controller: ScrollController(),
      animationDuration: Duration(milliseconds: 350),
      headers: [
        TecfyHeader.builder(
            pinned: true,
            builder: (progress) => Row(
                  children: [
                    Text(
                      ' Employees Page',
                      style: TextStyle(fontSize: (progress * 23) + 23),
                    ),
                  ],
                ),
            maxHeight: 60,
            minHeight: 50,
            color: Colors.white),
        TecfyHeader.fixed(
          child: SizedBox(),
          height: 10,
          color: Colors.white,
        ),
        // TecfyHeader.scale(
        //   scaleX: 0.5,
        //   scaleY: 0.5,
        //   maxHeight: 75,
        //   minHeight: 37,
        //   pinned: true,
        //   floating: true,
        //   elevation: 5,
        //   child: Padding(
        //     padding: const EdgeInsets.only(left: 10),
        //     child: Text(
        //       "Employee Page",
        //       style: TextStyle(fontSize: 50),
        //     ),
        //   ),
        // ),
        TecfyHeader.feedOut(
          child: Padding(
            padding: const EdgeInsets.all(15.0),
            child: TextField(
              textAlign: TextAlign.start,
              controller: controller.searchText,
              keyboardType: TextInputType.text,
              decoration: InputDecoration(
                hintText: 'Search ..',
                hintStyle: TextStyle(fontSize: 16),
                border: OutlineInputBorder(
                  borderRadius: BorderRadius.circular(8),
                  borderSide: BorderSide(
                    width: 0,
                    style: BorderStyle.none,
                  ),
                ),
                filled: true,
                contentPadding: EdgeInsets.all(16),
                suffixIcon: Icon(Icons.search),
                // fillColor: colorSearchBg,
              ),
            ),
          ),
          height: 80,
          color: Colors.white,
        ),
        TecfyHeader.transform(
            child: Align(
              alignment: Alignment.centerLeft,
              child: Icon(Icons.add),
            ),
            ShrunkChild: Align(
              alignment: Alignment.centerLeft,
              child: Icon(Icons.close),
            ),
            expandedHeight: 35,
            ShrunkHeight: 35,
            pinned: true,
            color: Colors.white,
            elevation: 5),
      ],
      childrenBuilder: (BuildContext context, int i) {
        return ListTile(
          title: Text(controller.employeesAfterSearch[i].displayName),
          trailing: Text(controller.employeesAfterSearch[i].idValue),
        );
      },
      childrenCount: controller.employeesAfterSearch.length,
      backgroundColor: Colors.white,
      floatingActionButton: FloatingActionButton(
        child: Icon(Icons.add),
        onPressed: controller.onOpenNewEmployeePage,
        isExtended: true,
      ),

      // appBar: AppBar(title: Text('Employees')),
    );
    // return  Scaffold(
    //

    //   body: ListView.builder(
    //     itemCount: controller.employees.length,
    //     itemBuilder: (c, i) => ListTile(
    //       title: Text(controller.employees[i].displayName),
    //       trailing: Text(controller.employees[i].idValue),
    //     ),
    //   ),
    // );
  }
}
